--
-- wetDamageGuiexion600
-- Specialization for wetDamageGuiexion600
--
-- @author:		Michi77
-- @date:		10/07/16
-- @version:	v1.0
-- @history:	v1.0 - initial version
--
-- free for non-commercial usage
-- note: rafftnixGUI needed!!

wetDamageGui = {};

function wetDamageGui.prerequisitesPresent(specializations)
    return RafftnixGUI ~= nil;
end;

function wetDamageGui:load(xmlFile)
	--TODO: Move positioning to xml..
	self.wetDamageGui = RafftnixGUI:new(nil, false, false);
	self.closeGui = SpecializationUtil.callSpecializationsFunction("closeGui");
	self.openGui = SpecializationUtil.callSpecializationsFunction("openGui");

	local posX = getXMLFloat(xmlFile, "vehicle.wetDamageGui.backGround#x");
	local posY = getXMLFloat(xmlFile, "vehicle.wetDamageGui.backGround#y");
	local width = getXMLFloat(xmlFile, "vehicle.wetDamageGui.backGround#width");
	local bBackgroundHeight = getXMLFloat(xmlFile, "vehicle.wetDamageGui.backGround#height");
	local fileName = getXMLString(xmlFile, "vehicle.wetDamageGui.backGround#fileName");
	self.bBackground = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, posX, posY, width, bBackgroundHeight, fileName);
	
	
	self.posX = getXMLFloat(xmlFile, "vehicle.wetDamageGui.position#x");
	self.posY = getXMLFloat(xmlFile, "vehicle.wetDamageGui.position#y");
	self.width = getXMLFloat(xmlFile, "vehicle.wetDamageGui.position#width");
	self.height = getXMLFloat(xmlFile, "vehicle.wetDamageGui.position#height");	
	
	self.currentVehicleName = self.wetDamageGui:createText(self.wetDamageGui.baseElement, self.posX+0.025, self.posY+0.45, self.width, self.height, g_i18n:getText("CURRENT_VEHICLE"), 0.025, {1,1,1,1});
	self.fruittypeTXT = self.wetDamageGui:createText(self.wetDamageGui.baseElement, self.posX+0.025, self.posY+0.40, self.width, self.height, g_i18n:getText("CURRENT_FRUITTYPE"), 0.025, {1,1,1,1});
	self.curDmg = self.wetDamageGui:createText(self.wetDamageGui.baseElement, self.posX+0.025, self.posY+0.35, self.width, self.height, g_i18n:getText("CURRENT_WETDAMAGE"), 0.025, {1,1,1,1});
	self.curCutter = self.wetDamageGui:createText(self.wetDamageGui.baseElement, self.posX+0.025, self.posY+0.25, self.width, self.height, g_i18n:getText("CURRENT_CUTTER"), 0.025, {1,1,1,1});
	self.closeText = self.wetDamageGui:createText(self.wetDamageGui.baseElement, self.posX+0.125, self.posY+0.025, self.width, self.height, g_i18n:getText("MOUSE_CLICK_CLOSE"), 0.025, {1,1,1,1});
	self.closeImg = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.32, self.posY, 0.08, 0.08, Utils.getFilename("$dataS2/menu/controllerSymbols/mouse/mouseLMB.dds", self.baseDirectory), true);
	self.isOpenedGui = false;
	
	local strItemStoreImg = StoreItemsUtil.storeItemsByXMLFilename[self.configFileName:lower()].imageActive;
	local strItemBrandImg = StoreItemsUtil.storeItemsByXMLFilename[self.configFileName:lower()].imageBrand;
	strItemStoreImg = strItemStoreImg:gsub(".*//.-/","");
	--strItemStoreImg = strItemStoreImg:gsub("FS15_claasLexionPack/","");
	strItemBrandImg = strItemBrandImg:gsub(".*//.-/","");
	--strItemBrandImg = strItemBrandImg:gsub("FS15_claasLexionPack/","");
	
	self.storeImageGui = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.335, self.posY+0.35, 0.15, 0.15, strItemStoreImg);
	self.brandImageGui = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.335, self.posY+0.25, 0.15, 0.15, strItemBrandImg);
	
	self.cutterImage = self.baseDirectory.."hud/empty.dds";
	self.cutterBrand = self.baseDirectory.."hud/empty.dds";
	self.cutterImageGui = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.335, self.posY+0.15, 0.15, 0.15, self.cutterImage, true);
	self.cutterBrandGui = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.335, self.posY+0.05, 0.15, 0.15, self.cutterBrand, true);
end;

function wetDamageGui:delete()
end;

function wetDamageGui:mouseEvent(posX, posY, isDown, isUp, button)
end;

function wetDamageGui:keyEvent(unicode, sym, modifier, isDown)
end;

function wetDamageGui:update(dt)
	if g_currentMission.showHudEnv == false then
		self:closeGui();
	elseif self.isOpenedGui and InputBinding.hasEvent(InputBinding.WET_DAMAGEGUI_CLOSE) then
		self:closeGui();
		self.isOpenedGui = false;
	end;
end;

function wetDamageGui:closeGui()
	self.wetDamageGui:close();
end;

function wetDamageGui:openGui()
	self.wetDamageGui:open();
	for k, v in pairs(StoreItemsUtil.storeItemsByXMLFilename[self.configFileName:lower()]) do
		--print(k, v);
	end;
	local curDmgString = g_i18n:getText("CURRENT_WETDAMAGE") .. " " .. string.format("%.2f %%",100 - (self.threshingScale / self.origThreshingScale * 100));
	if self.currentFillType ~= nil and self.currentFillType ~= FruitUtil.FRUITTYPE_UNKNOWN then
	
		if Utils.getNoNil(self.currentFillType, 0) > 0 then 
			local nFruitType = FruitUtil.fillTypeToFruitType[self.currentFillType]
			if nFruitType ~= nil then 
				local sFruitDesc = FruitUtil.fruitIndexToDesc[nFruitType].name
				if g_i18n:hasText(sFruitDesc) then 
					sFillType = g_i18n:getText(sFruitDesc)
				end
			end
		end
		--self.fruittypeTXT.text = g_i18n:getText("CURRENT_FRUITTYPE") .. " " .. g_i18n:getText(FruitUtil.fruitIndexToDesc[self.currentFillType].name);
		self.fruittypeTXT.text = g_i18n:getText("CURRENT_FRUITTYPE") .. " " .. sFillType;
	elseif self.lastValidFillType ~= nil and self.lastValidFillType ~= FruitUtil.FRUITTYPE_UNKNOWN then
		--self.fruittypeTXT.text = g_i18n:getText("CURRENT_FRUITTYPE") .. " " .. g_i18n:getText(FruitUtil.fruitIndexToDesc[self.lastValidFillType].name);
		if Utils.getNoNil(self.lastValidFillType, 0) > 0 then 
			local nFruitType = FruitUtil.fillTypeToFruitType[self.lastValidFillType]
			if nFruitType ~= nil then 
				local sFruitDesc = FruitUtil.fruitIndexToDesc[nFruitType].name
				if g_i18n:hasText(sFruitDesc) then 
					sFillType = g_i18n:getText(sFruitDesc)
				end
			end
		end
		self.fruittypeTXT.text = g_i18n:getText("CURRENT_FRUITTYPE") .. " " .. g_i18n:getText(FruitUtil.fruitIndexToDesc[self.lastValidFillType].name);
	end;
	self.curDmg.text = curDmgString;
	self.currentVehicleName.text = g_i18n:getText("CURRENT_VEHICLE") .. " " .. StoreItemsUtil.storeItemsByXMLFilename[self.configFileName:lower()].name;
		if self.numAttachedCutters > 0 then 
		for c,implement in pairs(self.attachedCutters) do 
			if c ~= self then 
				self.cutterName = StoreItemsUtil.storeItemsByXMLFilename[self.configFileName:lower()].name;
				self.cutterImage = StoreItemsUtil.storeItemsByXMLFilename[c.configFileName:lower()].imageActive;
				self.cutterBrand = StoreItemsUtil.storeItemsByXMLFilename[c.configFileName:lower()].imageBrand;
				self.curCutter.text = g_i18n:getText("CURRENT_CUTTER") .. " " .. StoreItemsUtil.storeItemsByXMLFilename[c.configFileName:lower()].name;
				self.cutterImageGui = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.335, self.posY+0.15, 0.15, 0.15, self.cutterImage, true);
				self.cutterBrandGui = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.335, self.posY+0.05, 0.15, 0.15, self.cutterBrand, true);
			end;
		end;
	else
		self.cutterImage = "hud/empty.dds";
		self.cutterBrand = "hud/empty.dds";
		self.curCutter.text = g_i18n:getText("CURRENT_CUTTER");
		self.cutterImageGui = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.335, self.posY+0.15, 0.15, 0.15, self.cutterImage);
		self.cutterBrandGui = self.wetDamageGui:createImage(self.wetDamageGui.baseElement, self.posX+0.335, self.posY+0.05, 0.15, 0.15, self.cutterBrand);
	end;
end;

function wetDamageGui:draw()
end;